diff --git a/tests/test_workflow_import.py b/tests/test_workflow_import.py
index a2c65ffaf..d36db5e7b 100644
--- a/tests/test_workflow_import.py
+++ b/tests/test_workflow_import.py
@@ -1,12 +1,11 @@
 # -*- coding: utf-8 -*-
 
+import io
 import pytest
 import xml.etree.ElementTree as ET
 
 from quixote.http_request import Upload
 
-from django.utils.six import BytesIO
-
 from wcs.carddef import CardDef
 from wcs.formdef import FormDef
 from wcs.mail_templates import MailTemplate
@@ -202,7 +201,7 @@ def test_status_actions_named_existing_role(pub):
         b'<item role_id="2">Test Role named existing role</item>',
         b'<item>Test Role named existing role</item>',
     )
-    wf3 = Workflow.import_from_xml_tree(ET.parse(BytesIO(xml_export)))
+    wf3 = Workflow.import_from_xml_tree(ET.parse(io.BytesIO(xml_export)))
     assert wf3.possible_status[0].items[0].by == ['2']
 
 
@@ -235,7 +234,7 @@ def test_status_actions_named_missing_role(pub):
     xml_export = xml_export_orig.replace(
         b'<item role_id="3">Test Role A</item>', b'<item role_id="4">Test Role A</item>'
     )
-    wf3 = Workflow.import_from_xml_tree(ET.parse(BytesIO(xml_export)))
+    wf3 = Workflow.import_from_xml_tree(ET.parse(io.BytesIO(xml_export)))
     assert wf3.possible_status[0].items[0].by == ['3']
 
     # check that it creates a new role if there's no match on id and name
@@ -243,7 +242,7 @@ def test_status_actions_named_missing_role(pub):
         b'<item role_id="3">Test Role A</item>', b'<item role_id="999">foobar</item>'
     )
     nb_roles = Role.count()
-    wf3 = Workflow.import_from_xml_tree(ET.parse(BytesIO(xml_export)))
+    wf3 = Workflow.import_from_xml_tree(ET.parse(io.BytesIO(xml_export)))
     assert Role.count() == nb_roles + 1
 
     # check that it doesn't fallback on the id if there's no match on the
@@ -252,12 +251,12 @@ def test_status_actions_named_missing_role(pub):
     xml_export = xml_export_orig.replace(
         b'<item role_id="3">Test Role A</item>', b'<item role_id="3">Test Role C</item>'
     )
-    wf3 = Workflow.import_from_xml_tree(ET.parse(BytesIO(xml_export)))
+    wf3 = Workflow.import_from_xml_tree(ET.parse(io.BytesIO(xml_export)))
     assert wf3.possible_status[0].items[0].by != ['3']
     assert Role.count() == nb_roles + 1
 
     # on the other hand, check that it uses the id when included_id is True
-    wf3 = Workflow.import_from_xml_tree(ET.parse(BytesIO(xml_export)), include_id=True)
+    wf3 = Workflow.import_from_xml_tree(ET.parse(io.BytesIO(xml_export)), include_id=True)
     assert wf3.possible_status[0].items[0].by == ['3']
 
 
@@ -291,7 +290,7 @@ def test_export_to_model_action(pub):
     export_to.label = 'test'
     upload = Upload('/foo/bar', content_type='application/vnd.oasis.opendocument.text')
     file_content = b'''PK\x03\x04\x14\x00\x00\x08\x00\x00\'l\x8eG^\xc62\x0c\'\x00'''
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(file_content)
     upload.fp.seek(0)
     export_to.model_file = UploadedFile(pub.APP_DIR, None, upload)
@@ -308,7 +307,7 @@ def test_export_to_model_action(pub):
     export_to.label = 'test'
     upload = Upload('/foo/bar', content_type='text/rtf')
     file_content = b''
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(file_content)
     upload.fp.seek(0)
     export_to.model_file = UploadedFile(pub.APP_DIR, None, upload)
@@ -397,7 +396,7 @@ def test_commentable_action(pub):
     assert b'<required>True</required>' in xml_export
     xml_export = xml_export.replace(b'<required>True</required>', b'')
     assert b'<required>True</required>' not in xml_export
-    wf2 = Workflow.import_from_xml_tree(ET.parse(BytesIO(xml_export)))
+    wf2 = Workflow.import_from_xml_tree(ET.parse(io.BytesIO(xml_export)))
     assert wf2.possible_status[0].items[0].required is False
 
     commentable.button_label = 'button label'
@@ -930,7 +929,7 @@ def test_unknown_data_source(pub):
     for wf in [wf1, wf2, wf3]:
         export = ET.tostring(export_to_indented_xml(wf))
         with pytest.raises(WorkflowImportError, match='Unknown datasources'):
-            Workflow.import_from_xml(BytesIO(export))
+            Workflow.import_from_xml(io.BytesIO(export))
 
     # carddef as datasource
     CardDef.wipe()
@@ -945,7 +944,7 @@ def test_unknown_data_source(pub):
 
     for wf in [wf1, wf2, wf3]:
         export = ET.tostring(export_to_indented_xml(wf))
-        Workflow.import_from_xml(BytesIO(export))
+        Workflow.import_from_xml(io.BytesIO(export))
 
     display_form.formdef.fields[0].data_source = {'type': 'carddef:unknown'}
     wf2.variables_formdef.fields[0].data_source = {'type': 'carddef:unknown'}
@@ -954,7 +953,7 @@ def test_unknown_data_source(pub):
     for wf in [wf1, wf2, wf3]:
         export = ET.tostring(export_to_indented_xml(wf))
         with pytest.raises(WorkflowImportError, match='Unknown datasources'):
-            Workflow.import_from_xml(BytesIO(export))
+            Workflow.import_from_xml(io.BytesIO(export))
 
     # carddef custom view as datasource
     pub.custom_view_class.wipe()
@@ -972,7 +971,7 @@ def test_unknown_data_source(pub):
 
     for wf in [wf1, wf2, wf3]:
         export = ET.tostring(export_to_indented_xml(wf))
-        Workflow.import_from_xml(BytesIO(export))
+        Workflow.import_from_xml(io.BytesIO(export))
 
     display_form.formdef.fields[0].data_source = {'type': 'carddef:foo:unknown'}
     wf2.variables_formdef.fields[0].data_source = {'type': 'carddef:foo:unknown'}
@@ -981,4 +980,4 @@ def test_unknown_data_source(pub):
     for wf in [wf1, wf2, wf3]:
         export = ET.tostring(export_to_indented_xml(wf))
         with pytest.raises(WorkflowImportError, match='Unknown datasources'):
-            Workflow.import_from_xml(BytesIO(export))
+            Workflow.import_from_xml(io.BytesIO(export))
diff --git a/tests/test_workflows.py b/tests/test_workflows.py
index 915896970..8ee3db3f9 100644
--- a/tests/test_workflows.py
+++ b/tests/test_workflows.py
@@ -1,4 +1,5 @@
 import base64
+import io
 import json
 import datetime
 import os
@@ -14,10 +15,8 @@ try:
 except ImportError:
     Image = None
 
-from django.utils import six
 from django.utils.encoding import force_bytes, force_text
-from django.utils.six import BytesIO, StringIO
-from django.utils.six.moves.urllib import parse as urlparse
+import urllib.parse
 
 from quixote import cleanup, get_response
 from wcs.qommon.errors import ConnectionError
@@ -1008,7 +1007,7 @@ def test_register_comment_attachment(pub):
         shutil.rmtree(os.path.join(get_publisher().app_dir, 'attachments'))
 
     formdata.evolution[-1].parts = [
-        AttachmentEvolutionPart('hello.txt', fp=BytesIO(b'hello world'), varname='testfile')
+        AttachmentEvolutionPart('hello.txt', fp=io.BytesIO(b'hello world'), varname='testfile')
     ]
     formdata.store()
     assert len(os.listdir(os.path.join(get_publisher().app_dir, 'attachments'))) == 1
@@ -1961,7 +1960,7 @@ def test_webservice_call(http_requests, pub):
     pub.substitutions.feed(formdata)
     item.perform(formdata)
     assert http_requests.get_last('method') == 'GET'
-    qs = urlparse.parse_qs(http_requests.get_last('url').split('?')[1])
+    qs = urllib.parse.parse_qs(http_requests.get_last('url').split('?')[1])
     assert set(qs.keys()) == set(['in_url', 'str', 'one', 'evalme', 'django', 'ezt'])
     assert qs['in_url'] == ['1', '2']
     assert qs['one'] == ['1']
@@ -3188,7 +3187,7 @@ def test_geolocate_address(pub):
         )
         item.perform(formdata)
         assert 'https://nominatim.entrouvert.org/search' in http_get_page.call_args[0][0]
-        assert urlparse.quote('169 rue du chateau, paris') in http_get_page.call_args[0][0]
+        assert urllib.parse.quote('169 rue du chateau, paris') in http_get_page.call_args[0][0]
         assert int(formdata.geolocations['base']['lat']) == 48
         assert int(formdata.geolocations['base']['lon']) == 2
 
@@ -3203,7 +3202,7 @@ def test_geolocate_address(pub):
         )
         item.perform(formdata)
         assert 'https://nominatim.entrouvert.org/search' in http_get_page.call_args[0][0]
-        assert urlparse.quote('169 rue du chateau, paris') in http_get_page.call_args[0][0]
+        assert urllib.parse.quote('169 rue du chateau, paris') in http_get_page.call_args[0][0]
         assert 'key=KEY' in http_get_page.call_args[0][0]
         assert int(formdata.geolocations['base']['lat']) == 48
         assert int(formdata.geolocations['base']['lon']) == 2
@@ -3435,7 +3434,7 @@ def test_export_to_model_image(pub):
     template_filename = os.path.join(os.path.dirname(__file__), 'template-with-image.odt')
     template = open(template_filename, 'rb').read()
     upload = QuixoteUpload('/foo/template.odt', content_type='application/octet-stream')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(template)
     upload.fp.seek(0)
     item.model_file = UploadedFile(pub.app_dir, None, upload)
@@ -3499,7 +3498,7 @@ def test_export_to_model_backoffice_field(pub):
     template_filename = os.path.join(os.path.dirname(__file__), 'template.odt')
     template = open(template_filename, 'rb').read()
     upload = QuixoteUpload('/foo/template.odt', content_type='application/octet-stream')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(template)
     upload.fp.seek(0)
     item.model_file = UploadedFile(pub.app_dir, None, upload)
@@ -3557,7 +3556,7 @@ def test_export_to_model_django_template(pub):
     template_filename = os.path.join(os.path.dirname(__file__), 'template-django.odt')
     template = open(template_filename, 'rb').read()
     upload = QuixoteUpload('/foo/template-django.odt', content_type='application/octet-stream')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(template)
     upload.fp.seek(0)
     item.model_file = UploadedFile(pub.app_dir, None, upload)
@@ -3629,7 +3628,7 @@ def test_export_to_model_form_details_section(pub, filename):
     template_filename = os.path.join(os.path.dirname(__file__), filename)
     template = open(template_filename, 'rb').read()
     upload = QuixoteUpload(filename, content_type='application/octet-stream')
-    upload.fp = BytesIO()
+    upload.fp = io.BytesIO()
     upload.fp.write(template)
     upload.fp.seek(0)
     item.model_file = UploadedFile(pub.app_dir, None, upload)
diff --git a/tests/utilities.py b/tests/utilities.py
index ae5785efd..09031ad80 100644
--- a/tests/utilities.py
+++ b/tests/utilities.py
@@ -14,7 +14,7 @@ from webtest import TestApp
 from quixote import cleanup, get_publisher
 from django.conf import settings
 from django.utils.encoding import force_bytes, force_text
-from django.utils.six.moves.urllib import parse as urlparse
+import urllib.parse
 
 from wcs.qommon import force_str
 import wcs
@@ -330,8 +330,8 @@ class HttpRequestsMocking(object):
             {'url': url, 'method': method, 'body': body, 'headers': headers, 'timeout': timeout}
         )
 
-        scheme, netloc, path, params, query, fragment = urlparse.urlparse(url)
-        base_url = urlparse.urlunparse((scheme, netloc, path, '', '', ''))
+        scheme, netloc, path, params, query, fragment = urllib.parse.urlparse(url)
+        base_url = urllib.parse.urlunparse((scheme, netloc, path, '', '', ''))
 
         with open(os.path.join(os.path.dirname(__file__), 'idp_metadata.xml')) as fd:
             metadata = fd.read()
diff --git a/wcs/admin/forms.py b/wcs/admin/forms.py
index 11c378734..997336696 100644
--- a/wcs/admin/forms.py
+++ b/wcs/admin/forms.py
@@ -16,14 +16,13 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, see <http://www.gnu.org/licenses/>.
 
+import io
 import xml.etree.ElementTree as ET
 import datetime
 import difflib
 import tarfile
 import time
 
-from django.utils.six import BytesIO, StringIO
-
 from quixote import get_publisher, get_response, redirect
 from quixote.directory import Directory, AccessControlled
 from quixote.html import TemplateIO, htmltext
@@ -1247,7 +1246,7 @@ class FormDefPage(Directory):
         if form.get_widget('file').parse():
             fp = form.get_widget('file').parse().fp
         elif form.get_widget('new_formdef').parse():
-            fp = StringIO(form.get_widget('new_formdef').parse())
+            fp = io.StringIO(form.get_widget('new_formdef').parse())
         elif form.get_widget('url').parse():
             url = form.get_widget('url').parse()
             try:
@@ -1513,7 +1512,7 @@ class FormDefPage(Directory):
                     date = time.strptime(date, misc.date_format())
                     all_forms = [x for x in all_forms if x.last_update_time < date]
 
-                self.fd = BytesIO()
+                self.fd = io.BytesIO()
                 t = tarfile.open('wcs.tar.gz', 'w:gz', fileobj=self.fd)
                 t.add(self.formdef.get_object_filename(), 'formdef')
                 for formdata in all_forms:
diff --git a/wcs/admin/settings.py b/wcs/admin/settings.py
index 87928cc89..3a53b11e5 100644
--- a/wcs/admin/settings.py
+++ b/wcs/admin/settings.py
@@ -16,6 +16,7 @@
 
 import copy
 import hashlib
+import io
 import mimetypes
 import os
 
@@ -29,7 +30,6 @@ import shutil
 import xml.etree.ElementTree as ET
 
 from django.utils.encoding import force_bytes
-from django.utils.six import BytesIO, StringIO
 
 from quixote import get_publisher, get_request, get_response, redirect
 from quixote.directory import Directory
@@ -814,7 +814,7 @@ class SettingsDirectory(QommonSettingsDirectory):
             return redirect('themes')
 
         parent_theme_directory = os.path.dirname(theme_directory)
-        c = BytesIO()
+        c = io.BytesIO()
         z = zipfile.ZipFile(c, 'w')
         for base, dirnames, filenames in os.walk(theme_directory):
             basetheme = base[len(parent_theme_directory) + 1 :]
@@ -877,7 +877,7 @@ class SettingsDirectory(QommonSettingsDirectory):
             get_session().message = ('error', _('Theme is missing a desc.xml file.'))
             return redirect('themes')
         desc_xml = z.read('%s/desc.xml' % theme_name)
-        theme_dict = template.get_theme_dict(StringIO(force_text(desc_xml)))
+        theme_dict = template.get_theme_dict(io.StringIO(force_text(desc_xml)))
         if theme_dict.get('name') != theme_name:
             get_session().message = ('error', _('desc.xml is missing a name attribute.'))
             return redirect('themes')
@@ -901,7 +901,7 @@ class SettingsDirectory(QommonSettingsDirectory):
             get_session().message = ('error', _('Error loading theme (%s).') % str(e))
             return redirect('themes')
 
-        return self.install_theme_from_file(StringIO(fp.read()))
+        return self.install_theme_from_file(io.StringIO(fp.read()))
 
     def template(self):
         from wcs.qommon.template import get_default_ezt_template
@@ -994,7 +994,7 @@ class SettingsDirectory(QommonSettingsDirectory):
                 self.settings = settings
 
             def export(self, job):
-                c = BytesIO()
+                c = io.BytesIO()
                 z = zipfile.ZipFile(c, 'w')
                 for d in self.dirs:
                     if d not in (
diff --git a/wcs/admin/users.py b/wcs/admin/users.py
index caf54fe7e..a8a3d48ab 100644
--- a/wcs/admin/users.py
+++ b/wcs/admin/users.py
@@ -14,8 +14,6 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, see <http://www.gnu.org/licenses/>.
 
-from django.utils import six
-
 from quixote import get_publisher, get_response, get_request, get_session, redirect
 from quixote.directory import Directory
 from quixote.html import TemplateIO, htmltext
@@ -327,7 +325,7 @@ class UsersDirectory(Directory):
         checked_roles = None
         if get_request().form.get('filter'):
             checked_roles = get_request().form.get('role', [])
-            if isinstance(checked_roles, six.string_types):
+            if isinstance(checked_roles, str):
                 checked_roles = [checked_roles]
 
         if checked_roles:
diff --git a/wcs/admin/workflows.py b/wcs/admin/workflows.py
index dc179f431..fc835b714 100644
--- a/wcs/admin/workflows.py
+++ b/wcs/admin/workflows.py
@@ -18,14 +18,13 @@
 
 from __future__ import print_function
 
+import io
 import time
 from subprocess import Popen, PIPE
 import textwrap
 import xml.etree.ElementTree as ET
 
-from django.utils import six
 from django.utils.encoding import force_bytes
-from django.utils.six import StringIO
 
 from quixote import redirect, get_publisher, get_response
 from quixote.directory import Directory
@@ -132,7 +131,7 @@ def graphviz_post_treatment(content, colours, include=False):
 
 
 def graphviz(workflow, url_prefix='', select=None, svg=True, include=False):
-    out = StringIO()
+    out = io.StringIO()
     # a list of colours known to graphviz, they will serve as key to get back
     # to the colours defined in wcs, they are used as color attributes in
     # graphviz (<= 2.38) then as class attribute on node elements for 2.40 and
diff --git a/wcs/api.py b/wcs/api.py
index 13afcdca3..99fcd8451 100644
--- a/wcs/api.py
+++ b/wcs/api.py
@@ -24,7 +24,7 @@ from quixote.errors import MethodNotAllowedError
 from quixote.directory import Directory
 
 from django.utils.encoding import force_text
-from django.utils.six.moves.urllib import parse as urllib
+import urllib.parse
 from django.http import HttpResponse, HttpResponseBadRequest, JsonResponse
 
 from .qommon import _
@@ -956,7 +956,7 @@ class AutocompleteDirectory(Directory):
 
         if 'url' in info:
             url = info['url']
-            url += urllib.quote(get_request().form['q'])
+            url += urllib.parse.quote(get_request().form['q'])
             url = sign_url_auto_orig(url)
             get_response().set_content_type('application/json')
             return misc.urlopen(url).read()
@@ -1050,7 +1050,7 @@ def geocoding(request, *args, **kwargs):
         url += '&'
     else:
         url += '?'
-    url += 'format=json&q=%s' % urllib.quote(q.encode('utf-8'))
+    url += 'format=json&q=%s' % urllib.parse.quote(q.encode('utf-8'))
     url += '&accept-language=%s' % (get_publisher().get_site_language() or 'en')
     return HttpResponse(misc.urlopen(url).read(), content_type='application/json')
 
diff --git a/wcs/api_utils.py b/wcs/api_utils.py
index b986956a7..ab253fc7e 100644
--- a/wcs/api_utils.py
+++ b/wcs/api_utils.py
@@ -20,13 +20,11 @@ import hashlib
 import datetime
 import random
 import os
+import urllib.parse
 import errno
 import calendar
 
-from django.utils import six
 from django.utils.encoding import force_bytes, force_text
-from django.utils.six.moves.urllib import parse as urllib
-from django.utils.six.moves.urllib import parse as urlparse
 
 from quixote import get_request, get_publisher
 from .api_access import ApiAccess
@@ -43,18 +41,18 @@ def is_url_signed(utcnow=None, duration=DEFAULT_DURATION):
     if not query_string:
         return False
     signature = get_request().form.get('signature')
-    if not isinstance(signature, six.string_types):
+    if not isinstance(signature, str):
         return False
     signature = force_bytes(signature)
     # verify signature
     orig = get_request().form.get('orig')
-    if not isinstance(orig, six.string_types):
+    if not isinstance(orig, str):
         raise AccessForbiddenError('missing/multiple orig field')
     key = ApiAccess.get_access_key(orig) or get_publisher().get_site_option(orig, 'api-secrets')
     if not key:
         raise AccessForbiddenError('invalid orig')
     algo = get_request().form.get('algo')
-    if not isinstance(algo, six.string_types):
+    if not isinstance(algo, str):
         raise AccessForbiddenError('missing/multiple algo field')
     if algo not in hashlib.algorithms_guaranteed:
         raise AccessForbiddenError('invalid algo')
@@ -69,7 +67,7 @@ def is_url_signed(utcnow=None, duration=DEFAULT_DURATION):
     ):
         raise AccessForbiddenError('invalid signature')
     timestamp = get_request().form.get('timestamp')
-    if not isinstance(timestamp, six.string_types):
+    if not isinstance(timestamp, str):
         raise AccessForbiddenError('missing/multiple timestamp field')
     try:
         timestamp = datetime.datetime.strptime(timestamp, '%Y-%m-%dT%H:%M:%SZ')
@@ -133,7 +131,7 @@ def get_user_from_api_query_string(api_name=None):
     user = None
     if get_request().form.get('email'):
         email = get_request().form.get('email')
-        if not isinstance(email, six.string_types):
+        if not isinstance(email, str):
             raise AccessForbiddenError('multiple email field')
         users = list(get_publisher().user_class.get_users_with_email(email))
         if users:
@@ -142,7 +140,7 @@ def get_user_from_api_query_string(api_name=None):
             raise AccessForbiddenError('unknown email')
     elif get_request().form.get('NameID'):
         ni = get_request().form.get('NameID')
-        if not isinstance(ni, six.string_types):
+        if not isinstance(ni, str):
             raise AccessForbiddenError('multiple NameID field')
         users = list(get_publisher().user_class.get_users_with_name_identifier(ni))
         if users:
@@ -158,9 +156,9 @@ def get_user_from_api_query_string(api_name=None):
 
 
 def sign_url(url, key, algo='sha256', timestamp=None, nonce=None):
-    parsed = urlparse.urlparse(url)
+    parsed = urllib.parse.urlparse(url)
     new_query = sign_query(parsed.query, key, algo, timestamp, nonce)
-    return urlparse.urlunparse(parsed[:4] + (new_query,) + parsed[5:])
+    return urllib.parse.urlunparse(parsed[:4] + (new_query,) + parsed[5:])
 
 
 def sign_query(query, key, algo='sha256', timestamp=None, nonce=None):
@@ -173,9 +171,9 @@ def sign_query(query, key, algo='sha256', timestamp=None, nonce=None):
     new_query = query
     if new_query:
         new_query += '&'
-    new_query += urllib.urlencode((('algo', algo), ('timestamp', timestamp), ('nonce', nonce)))
+    new_query += urllib.parse.urlencode((('algo', algo), ('timestamp', timestamp), ('nonce', nonce)))
     signature = base64.b64encode(sign_string(new_query, key, algo=algo))
-    new_query += '&signature=' + urllib.quote(signature)
+    new_query += '&signature=' + urllib.parse.quote(signature)
     return new_query
 
 
@@ -191,8 +189,8 @@ class MissingSecret(Exception):
 
 def get_secret_and_orig(url):
     frontoffice_url = get_publisher().get_frontoffice_url()
-    orig = urlparse.urlparse(frontoffice_url).netloc.rsplit('@', 1)[-1].rsplit(':', 1)[0]
-    target_orig = urlparse.urlparse(url).netloc.rsplit('@', 1)[-1].rsplit(':', 1)[0]
+    orig = urllib.parse.urlparse(frontoffice_url).netloc.rsplit('@', 1)[-1].rsplit(':', 1)[0]
+    target_orig = urllib.parse.urlparse(url).netloc.rsplit('@', 1)[-1].rsplit(':', 1)[0]
     secret = get_publisher().get_site_option(target_orig, 'wscall-secrets')
     if not secret:
         raise MissingSecret()
@@ -204,11 +202,11 @@ def sign_url_auto_orig(url):
         signature_key, orig = get_secret_and_orig(url)
     except MissingSecret:
         return url
-    parsed = urlparse.urlparse(url)
-    querystring = urlparse.parse_qsl(parsed.query)
+    parsed = urllib.parse.urlparse(url)
+    querystring = urllib.parse.parse_qsl(parsed.query)
     querystring.append(('orig', orig))
-    querystring = urllib.urlencode(querystring)
-    url = urlparse.urlunparse(parsed[:4] + (querystring,) + parsed[5:6])
+    querystring = urllib.parse.urlencode(querystring)
+    url = urllib.parse.urlunparse(parsed[:4] + (querystring,) + parsed[5:6])
     return sign_url(url, signature_key)
 
 
diff --git a/wcs/backoffice/data_management.py b/wcs/backoffice/data_management.py
index 910b60fed..713a54f43 100644
--- a/wcs/backoffice/data_management.py
+++ b/wcs/backoffice/data_management.py
@@ -16,12 +16,12 @@
 
 import csv
 import datetime
+import io
 
 from quixote import get_publisher, get_request, get_response, redirect
 from quixote.html import TemplateIO, htmltext, htmlescape
 
 from django.utils.encoding import force_text
-from django.utils.six import StringIO
 
 
 from ..qommon import _, N_
@@ -169,7 +169,7 @@ class CardPage(FormPage):
 
     def data_sample_csv(self):
         carddef_fields = self.get_import_csv_fields()
-        output = StringIO()
+        output = io.StringIO()
         csv_output = csv.writer(output)
         csv_output.writerow([f.label for f in carddef_fields])
         sample_line = []
diff --git a/wcs/backoffice/management.py b/wcs/backoffice/management.py
index 27e454b7c..e1cfd458f 100644
--- a/wcs/backoffice/management.py
+++ b/wcs/backoffice/management.py
@@ -16,18 +16,17 @@
 
 import csv
 import datetime
+import io
 import json
 import re
 import time
 import types
+import urllib.parse
 import vobject
 import zipfile
 
 from django.conf import settings
-from django.utils import six
 from django.utils.encoding import force_text
-from django.utils.six.moves.urllib import parse as urllib
-from django.utils.six import BytesIO, StringIO
 
 from quixote import get_session, get_publisher, get_request, get_response, redirect
 from quixote.directory import Directory
@@ -904,7 +903,7 @@ class ManagementDirectory(Directory):
         total_count = sql.AnyFormData.count(criterias)
         if offset > total_count:
             get_request().form['offset'] = '0'
-            return redirect('listing?' + urllib.urlencode(get_request().form))
+            return redirect('listing?' + urllib.parse.urlencode(get_request().form))
         formdatas = sql.AnyFormData.select(criterias, order_by=order_by, limit=limit, offset=offset)
         include_submission_channel = bool(get_publisher().get_site_option('welco_url', 'variables'))
 
@@ -2937,7 +2936,7 @@ class FormBackOfficeStatusPage(FormStatusPage):
 
     def download_as_zip(self):
         formdata = self.filled
-        zip_content = BytesIO()
+        zip_content = io.BytesIO()
         zip_file = zipfile.ZipFile(zip_content, 'w')
         counter = {'value': 0}
 
@@ -3281,7 +3280,7 @@ class FormBackOfficeStatusPage(FormStatusPage):
             else:
                 r += htmltext('<li><code title="%s">%s</code>') % (k, k)
                 r += htmltext('  <div class="value"><span>%s</span>') % ellipsize(safe(v), 10000)
-                if not isinstance(v, six.string_types):
+                if not isinstance(v, str):
                     r += htmltext(' <span class="type">(%r)</span>') % type(v)
             r += htmltext('</div></li>')
         r += htmltext('</div>')
@@ -3706,7 +3705,7 @@ class CsvExportAfterJob(AfterJob):
         return self.create_export(formdef, fields, items, total_count)
 
     def create_export(self, formdef, fields, items, total_count):
-        output = StringIO()
+        output = io.StringIO()
         csv_output = csv.writer(output)
 
         csv_output.writerow(self.csv_tuple_heading(fields))
@@ -3752,7 +3751,7 @@ class OdsExportAfterJob(CsvExportAfterJob):
                     native_value=item['native_value'],
                 )
 
-        output = BytesIO()
+        output = io.BytesIO()
         workbook.save(output)
 
         self.file_content = output.getvalue()
diff --git a/wcs/carddata.py b/wcs/carddata.py
index 7f1ebaa50..8f358ec3b 100644
--- a/wcs/carddata.py
+++ b/wcs/carddata.py
@@ -14,8 +14,6 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, see <http://www.gnu.org/licenses/>.
 
-from django.utils import six
-
 from wcs.formdata import FormData
 
 
@@ -43,7 +41,7 @@ class CardData(FormData):
             if not field.varname:
                 continue
             value = self.data and self.data.get(field.id)
-            if isinstance(value, six.string_types):
+            if isinstance(value, str):
                 item[field.varname] = value
         return item
 
diff --git a/wcs/ctl/check_hobos.py b/wcs/ctl/check_hobos.py
index 4b9232ffe..e3c5a7fc6 100644
--- a/wcs/ctl/check_hobos.py
+++ b/wcs/ctl/check_hobos.py
@@ -23,10 +23,9 @@ import sys
 import tempfile
 import hashlib
 
-from django.utils import six
 from django.utils.encoding import force_bytes, force_text
-from django.utils.six.moves import configparser as ConfigParser
-from django.utils.six.moves.urllib import parse as urlparse
+import configparser
+import urllib.parse
 
 from quixote import cleanup
 from wcs.qommon import force_str
@@ -365,7 +364,7 @@ class CmdCheckHobos(Command):
             pub.write_cfg()
 
     def get_instance_path(self, service):
-        parsed_url = urlparse.urlsplit(service.get('base_url'))
+        parsed_url = urllib.parse.urlsplit(service.get('base_url'))
         instance_path = parsed_url.netloc
         if parsed_url.path:
             instance_path += '+%s' % parsed_url.path.replace('/', '+')
@@ -373,7 +372,7 @@ class CmdCheckHobos(Command):
 
     def configure_site_options(self, current_service, pub, ignore_timestamp=False):
         # configure site-options.cfg
-        config = ConfigParser.RawConfigParser()
+        config = configparser.RawConfigParser()
         site_options_filepath = os.path.join(pub.app_dir, 'site-options.cfg')
         if os.path.exists(site_options_filepath):
             config.read(site_options_filepath)
@@ -382,7 +381,7 @@ class CmdCheckHobos(Command):
             try:
                 if config.get('hobo', 'timestamp') == self.all_services.get('timestamp'):
                     raise NoChange()
-            except (ConfigParser.NoOptionError, ConfigParser.NoSectionError):
+            except (configparser.NoOptionError, configparser.NoSectionError):
                 pass
 
         if not 'hobo' in config.sections():
@@ -404,7 +403,7 @@ class CmdCheckHobos(Command):
             if not service.get('secret_key'):
                 continue
 
-            domain = urlparse.urlparse(service_url).netloc.split(':')[0]
+            domain = urllib.parse.urlparse(service_url).netloc.split(':')[0]
             if service is current_service:
                 if config.has_option('api-secrets', domain):
                     api_secrets[domain] = config.get('api-secrets', domain)
@@ -455,7 +454,7 @@ class CmdCheckHobos(Command):
                 if value is None:
                     config.remove_option('variables', key)
                     continue
-                if not isinstance(value, six.string_types):
+                if not isinstance(value, str):
                     value = str(value)
                 value = force_str(value)
                 config.set('variables', key, value)
@@ -480,7 +479,7 @@ class CmdCheckHobos(Command):
 
         try:
             portal_agent_url = config.get('variables', 'portal_agent_url')
-        except ConfigParser.NoOptionError:
+        except configparser.NoOptionError:
             pass
         else:
             if portal_agent_url.endswith('/'):
@@ -531,7 +530,7 @@ class CmdCheckHobos(Command):
         if not createdb_cfg:
             createdb_cfg = {}
             for k, v in pub.cfg['postgresql'].items():
-                if v and isinstance(v, six.string_types):
+                if v and isinstance(v, str):
                     createdb_cfg[k] = v
 
         try:
